Debian Bug report logs - #532627
kfreebsd-image-7.2-1-amd64: biarch support broken

version graph

Package: kfreebsd-image-7.2-1-amd64; Maintainer for kfreebsd-image-7.2-1-amd64 is (unknown);

Reported by: Aurelien Jarno <aurel32@debian.org>

Date: Wed, 10 Jun 2009 14:09:02 UTC

Severity: grave

Tags: pending

Found in version kfreebsd-7/7.2-1

Fixed in version kfreebsd-7/7.2-2

Done: Aurelien Jarno <aurel32@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#532627; Package kfreebsd-image-7.2-1-amd64. (Wed, 10 Jun 2009 14:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurel32@debian.org>:
New Bug report received and forwarded. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 10 Jun 2009 14:09:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurel32@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: kfreebsd-image-7.2-1-amd64: biarch support broken
Date: Wed, 10 Jun 2009 16:06:29 +0200
Package: kfreebsd-image-7.2-1-amd64
Version: 7.2-1
Severity: grave
Justification: renders package unusable

Starting with kernel 7.2, upstream has changed the way a binary type is
detected. This prevent 32-bit binaries to work.

On kFreeBSD 7.1, the following tests are done (in this order):
- ELF EI_OSABI
- interpreter
- ELF brand

On kFreeBSD 7.2, a 4th test has been added (in this order):
- .note.ABI-tag
- ELF EI_OSABI
- interpreter
- ELF brand

If .note.ABI-tag contains among other things "FreeBSD", the FreeBSD
execution environment is used, while if it contains "GNU", the Linux
execution environment is used. Our binaries contains "GNU" as on 
plain GNU/Linux, which breaks 32-bit support.

While we could remove/move this new check, this clearly differs from 
upstream. Any other idea?

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: kfreebsd-amd64 (x86_64)

Kernel: kFreeBSD 7.2-1-amd64
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages kfreebsd-image-7.2-1-amd64 depends on:
ii  freebsd-utils                 7.1-5      FreeBSD utilities needed for GNU/k
ii  kldutils                      7.1-5      tools for managing kFreeBSD module

kfreebsd-image-7.2-1-amd64 recommends no packages.

kfreebsd-image-7.2-1-amd64 suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#532627; Package kfreebsd-image-7.2-1-amd64. (Wed, 10 Jun 2009 17:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Salinger <Petr.Salinger@seznam.cz>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 10 Jun 2009 17:21:05 GMT) Full text and rfc822 format available.

Message #10 received at 532627@bugs.debian.org (full text, mbox):

From: Petr Salinger <Petr.Salinger@seznam.cz>
To: 532627@bugs.debian.org
Subject: Re: Bug#532627: kfreebsd-image-7.2-1-amd64: biarch support broken
Date: Wed, 10 Jun 2009 19:44:50 +0200 (CEST)
> Severity: grave
> Justification: renders package unusable

I would just say "important" as it prevents only 32-bit binaries to work,
64-bit binaries works for me for weeks ...

> If .note.ABI-tag contains among other things "FreeBSD", the FreeBSD
> execution environment is used, while if it contains "GNU", the Linux
> execution environment is used. Our binaries contains "GNU" as on
> plain GNU/Linux, which breaks 32-bit support.
>
> While we could remove/move this new check, this clearly differs from
> upstream. Any other idea?

They are checking the .note.ABI-tag in a bad way.
They should not only check the "GNU", but also whether OS field matches,
see [1], [2], [3].

The OS field is 0 for GNU/Linux and 3 for GNU/kFreeBSD, see [2].

The FreeBSD project decided to use different layout of the .note.ABI-tag, 
see [4].

The proper solution would be to teach FreeBSD to check GNU notes properly.
I would just comment out the new check. In fact, we already differ from 
orginal FreeBSD due to debian/patches/010_ET_DYN.diff.

Petr

[1] http://www.netbsd.org/Documentation/kernel/elf-notes.html
[2] http://sources.redhat.com/cgi-bin/cvsweb.cgi/~checkout~/libc/csu/abi-note.S?rev=1.7&content-type=text/plain&cvsroot=glibc
[3] http://sources.redhat.com/cgi-bin/cvsweb.cgi/~checkout~/libc/abi-tags?rev=1.6&content-type=text/plain&cvsroot=glibc
[4] http://www.freebsd.org/cgi/cvsweb.cgi/src/lib/csu/common/crtbrand.c?rev=1.6




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#532627; Package kfreebsd-image-7.2-1-amd64. (Wed, 10 Jun 2009 18:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurelien@aurel32.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 10 Jun 2009 18:57:04 GMT) Full text and rfc822 format available.

Message #15 received at 532627@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Petr Salinger <Petr.Salinger@seznam.cz>, 532627@bugs.debian.org
Subject: Re: Bug#532627: kfreebsd-image-7.2-1-amd64: biarch support broken
Date: Wed, 10 Jun 2009 20:54:37 +0200
On Wed, Jun 10, 2009 at 07:44:50PM +0200, Petr Salinger wrote:
>> Severity: grave
>> Justification: renders package unusable
>
> I would just say "important" as it prevents only 32-bit binaries to work,
> 64-bit binaries works for me for weeks ...

This prevents almost all biarch packages to be built, including glibc, gcc,
gcj, gdc, etc. I had to downgrade the kernel on the build daemons to
version 7.1 to get those packages built. 

>> If .note.ABI-tag contains among other things "FreeBSD", the FreeBSD
>> execution environment is used, while if it contains "GNU", the Linux
>> execution environment is used. Our binaries contains "GNU" as on
>> plain GNU/Linux, which breaks 32-bit support.
>>
>> While we could remove/move this new check, this clearly differs from
>> upstream. Any other idea?
>
> They are checking the .note.ABI-tag in a bad way.
> They should not only check the "GNU", but also whether OS field matches,
> see [1], [2], [3].
>
> The OS field is 0 for GNU/Linux and 3 for GNU/kFreeBSD, see [2].
>
> The FreeBSD project decided to use different layout of the .note.ABI-tag, 
> see [4].
>
> The proper solution would be to teach FreeBSD to check GNU notes properly.
> I would just comment out the new check. In fact, we already differ from  
> orginal FreeBSD due to debian/patches/010_ET_DYN.diff.
>

I am fine with removing the check for now (or maybe removing
BI_BRAND_NOTE from sys/amd64/linux32/linux32_sysvec.c), I was more
speaking about a more long term solution that may be merged upstream,
like checking the OS field correctly.

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#532627; Package kfreebsd-image-7.2-1-amd64. (Thu, 11 Jun 2009 08:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Salinger <Petr.Salinger@seznam.cz>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 11 Jun 2009 08:06:02 GMT) Full text and rfc822 format available.

Message #20 received at 532627@bugs.debian.org (full text, mbox):

From: Petr Salinger <Petr.Salinger@seznam.cz>
To: 532627@bugs.debian.org
Subject: kfreebsd-image-7.2-1 for kfreebsd-i386 seriously broken
Date: Thu, 11 Jun 2009 10:31:11 +0200 (CEST)
Hi.

The 7.2-1 kernel package for kfreebsd-i386 is currently in NEW.

		!!! Do not install it !!!

>> I would just say "important" as it prevents only 32-bit binaries to work,
>> 64-bit binaries works for me for weeks ...
>
> This prevents almost all biarch packages to be built, including glibc, gcc,
> gcj, gdc, etc. I had to downgrade the kernel on the build daemons to
> version 7.1 to get those packages built.

It prevents all 32-bit binaries to work, on kfreebsd-i386 it means whole 
system. So, it is really "grave".

> I am fine with removing the check for now (or maybe removing
> BI_BRAND_NOTE from sys/amd64/linux32/linux32_sysvec.c), I was more
> speaking about a more long term solution that may be merged upstream,
> like checking the OS field correctly.

I have a slightly hackish patch with the check of the OS field.
After test on kfreebsd-i386 I will put in our SVN.

Petr




Reply sent to Aurelien Jarno <aurel32@debian.org>:
You have taken responsibility. (Fri, 12 Jun 2009 10:36:06 GMT) Full text and rfc822 format available.

Notification sent to Aurelien Jarno <aurel32@debian.org>:
Bug acknowledged by developer. (Fri, 12 Jun 2009 10:36:06 GMT) Full text and rfc822 format available.

Message #25 received at 532627-close@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurel32@debian.org>
To: 532627-close@bugs.debian.org
Subject: Bug#532627: fixed in kfreebsd-7 7.2-2
Date: Fri, 12 Jun 2009 09:47:43 +0000
Source: kfreebsd-7
Source-Version: 7.2-2

We believe that the bug you reported is fixed in the latest version of
kfreebsd-7, which is due to be installed in the Debian FTP archive:

kfreebsd-7_7.2-2.diff.gz
  to pool/main/k/kfreebsd-7/kfreebsd-7_7.2-2.diff.gz
kfreebsd-7_7.2-2.dsc
  to pool/main/k/kfreebsd-7/kfreebsd-7_7.2-2.dsc
kfreebsd-headers-7-amd64_7.2-2_kfreebsd-amd64.deb
  to pool/main/k/kfreebsd-7/kfreebsd-headers-7-amd64_7.2-2_kfreebsd-amd64.deb
kfreebsd-headers-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
  to pool/main/k/kfreebsd-7/kfreebsd-headers-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
kfreebsd-headers-7.2-1_7.2-2_kfreebsd-amd64.deb
  to pool/main/k/kfreebsd-7/kfreebsd-headers-7.2-1_7.2-2_kfreebsd-amd64.deb
kfreebsd-image-7-amd64_7.2-2_kfreebsd-amd64.deb
  to pool/main/k/kfreebsd-7/kfreebsd-image-7-amd64_7.2-2_kfreebsd-amd64.deb
kfreebsd-image-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
  to pool/main/k/kfreebsd-7/kfreebsd-image-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
kfreebsd-source-7.2_7.2-2_all.deb
  to pool/main/k/kfreebsd-7/kfreebsd-source-7.2_7.2-2_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 532627@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Aurelien Jarno <aurel32@debian.org> (supplier of updated kfreebsd-7 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 12 Jun 2009 09:44:19 +0200
Source: kfreebsd-7
Binary: kfreebsd-source-7.2 kfreebsd-headers-7.2-1 kfreebsd-image-7.2-1-amd64 kfreebsd-image-7-amd64 kfreebsd-headers-7.2-1-amd64 kfreebsd-headers-7-amd64 kfreebsd-image-7.2-1-486 kfreebsd-image-7-486 kfreebsd-headers-7.2-1-486 kfreebsd-headers-7-486 kfreebsd-image-7.2-1-686-smp kfreebsd-image-7-686-smp kfreebsd-headers-7.2-1-686-smp kfreebsd-headers-7-686-smp kfreebsd-image-7.2-1-686 kfreebsd-image-7-686 kfreebsd-headers-7.2-1-686 kfreebsd-headers-7-686
Architecture: source all kfreebsd-amd64
Version: 7.2-2
Distribution: unstable
Urgency: low
Maintainer: Aurelien Jarno <aurel32@debian.org>
Changed-By: Aurelien Jarno <aurel32@debian.org>
Description: 
 kfreebsd-headers-7-486 - header files for kernel of FreeBSD 7
 kfreebsd-headers-7-686 - header files for kernel of FreeBSD 7
 kfreebsd-headers-7-686-smp - header files for kernel of FreeBSD 7
 kfreebsd-headers-7-amd64 - header files for kernel of FreeBSD 7
 kfreebsd-headers-7.2-1 - Common architecture-specific header files for kernel of FreeBSD 7
 kfreebsd-headers-7.2-1-486 - header files for kernel of FreeBSD 7.2
 kfreebsd-headers-7.2-1-686 - header files for kernel of FreeBSD 7.2
 kfreebsd-headers-7.2-1-686-smp - header files for kernel of FreeBSD 7.2
 kfreebsd-headers-7.2-1-amd64 - header files for kernel of FreeBSD 7.2
 kfreebsd-image-7-486 - kernel of FreeBSD 7 image
 kfreebsd-image-7-686 - kernel of FreeBSD 7 image
 kfreebsd-image-7-686-smp - kernel of FreeBSD 7 image
 kfreebsd-image-7-amd64 - kernel of FreeBSD 7 image
 kfreebsd-image-7.2-1-486 - kernel of FreeBSD 7.2 image
 kfreebsd-image-7.2-1-686 - kernel of FreeBSD 7.2 image
 kfreebsd-image-7.2-1-686-smp - kernel of FreeBSD 7.2 image
 kfreebsd-image-7.2-1-amd64 - kernel of FreeBSD 7.2 image
 kfreebsd-source-7.2 - source code for kernel of FreeBSD 7.2 with Debian patches
Closes: 532627
Changes: 
 kfreebsd-7 (7.2-2) unstable; urgency=low
 .
   [ Petr Salinger ]
   * 011_brandinfo.diff: fix the way a binary type is detected.
     The original upstream change in 7.2 prevented 32-bit binaries to work.
     It broke biarch support on kfreebsd-amd64 and whole kfreebsd-i386.
     Closes: #532627.
   * Fix local information disclosure via direct pipe writes
     (FreeBSD-SA-09:09.pipe).
   * Fix missing permission check on SIOCSIFINFO_IN6 ioctl
     (FreeBSD-SA-09:10.ipv6).
Checksums-Sha1: 
 0e22a03451a28501c3b6b1764fc3c299a16eebba 1869 kfreebsd-7_7.2-2.dsc
 7cfb818508da1b309d2e5334e998ee132208e3eb 31455 kfreebsd-7_7.2-2.diff.gz
 83f820cc3984a7dfa72b442f059ef42307344a22 19526652 kfreebsd-source-7.2_7.2-2_all.deb
 0eacc87fbf7437a526b8972a0fe9ac3ea0e13dcd 7320102 kfreebsd-headers-7.2-1_7.2-2_kfreebsd-amd64.deb
 d506f0aad6f218a9c2bcb2fb72aef28e5a9ec241 10941598 kfreebsd-image-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 32a200c2df2da5bf944c808d58ae612b07d8dd19 10372 kfreebsd-image-7-amd64_7.2-2_kfreebsd-amd64.deb
 45354856b74981fce237e12361733a6a1f08eb89 244220 kfreebsd-headers-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 11c8a890d0dea8efac33f7040034710ac96b06d5 10374 kfreebsd-headers-7-amd64_7.2-2_kfreebsd-amd64.deb
Checksums-Sha256: 
 08a1b4b80077750994f66b212cc4f975063d907aba0148963bf7fda17dce02ed 1869 kfreebsd-7_7.2-2.dsc
 8ac2c155ea14877a6a0f33a3a173a261c556eea2d8b3998d33f34b0e587b9ddd 31455 kfreebsd-7_7.2-2.diff.gz
 052b6bbeeb4daa172cf0e8d5d71479358abae4f71d4ed56e6b2b1cd6331675e7 19526652 kfreebsd-source-7.2_7.2-2_all.deb
 d3917d2f07a052d4a8c6f7325d7accdde5ce63faf8f7995af926bf878244ce24 7320102 kfreebsd-headers-7.2-1_7.2-2_kfreebsd-amd64.deb
 421b23497bad5a3299a8d4e8fe72b47385a77acd6f5e4c13463f2831d508fca3 10941598 kfreebsd-image-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 91f40b21c2bfa41e213273f73f7541587b48f3df7462b861ea9bb1a978ea6049 10372 kfreebsd-image-7-amd64_7.2-2_kfreebsd-amd64.deb
 76a0bfdd6de3452f6be654bd5b82252439ab5c47a888957e673458fbeb077f22 244220 kfreebsd-headers-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 772ae4c60ac73cf138935899f3b9cf9ba7171d374536f9223aa092fd869821a1 10374 kfreebsd-headers-7-amd64_7.2-2_kfreebsd-amd64.deb
Files: 
 1bfcea24d33e30aa23bea8f87c4a00ef 1869 kernel optional kfreebsd-7_7.2-2.dsc
 692b0eef12a4725ef734ffde9f67f176 31455 kernel optional kfreebsd-7_7.2-2.diff.gz
 3c3ede6f3b2a679860898b7a222db5ca 19526652 kernel optional kfreebsd-source-7.2_7.2-2_all.deb
 c6a0a273e3515da0b7cf541345cb4f1c 7320102 kernel optional kfreebsd-headers-7.2-1_7.2-2_kfreebsd-amd64.deb
 c47bc36bf431387be0836dd10a07fe1a 10941598 kernel optional kfreebsd-image-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 aede74bbd3717d3072af3db8e52a5a1d 10372 kernel optional kfreebsd-image-7-amd64_7.2-2_kfreebsd-amd64.deb
 952e013dd677affc46b319eb72ab93a4 244220 kernel optional kfreebsd-headers-7.2-1-amd64_7.2-2_kfreebsd-amd64.deb
 6ddb668589e17ef312165430f486d3bb 10374 kernel optional kfreebsd-headers-7-amd64_7.2-2_kfreebsd-amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/kFreeBSD)

iD8DBQFKMhV+w3ao2vG823MRAl4zAJ4s0f7u3aNC67824/f4tp99xe14pACfd8Kt
40As9/UXRD1UU87E8K9aGGo=
=jQWS
-----END PGP SIGNATURE-----





Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Sat, 13 Jun 2009 08:06:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 12 Jul 2009 07:28:48 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 20:13:57 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.